Index: pjproject/trunk/pjlib/build/pjlib.sln
===================================================================
--- pjproject/trunk/pjlib/build/pjlib.sln	(revision 124)
+++ pjproject/trunk/pjlib/build/pjlib.sln	(revision 138)
@@ -1,46 +1,28 @@
 Microsoft Visual Studio Solution File, Format Version 8.00
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib", "pjlib.vcproj", "{4A6465DC-D757-43F2-9180-60920E33522B}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib", "pjlib.vcproj", "{02D95A67-9434-4EBC-9A55-0F5DF912B61D}"
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib++", "pjlib++.vcproj", "{D124EDDD-ED22-43C0-9DDC-279BDEE7DF61}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib++", "pjlib++.vcproj", "{D80CE629-FF34-448B-BF5C-99C89AEE2360}"
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib++_test", "pjlib++-test.vcproj", "{2B01F39B-FF97-46BF-9CC8-26E3246ACA0E}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib++_test", "pjlib++-test.vcproj", "{4EB736BB-61BF-4D18-9BBE-1A9ED3E5A115}"
 	ProjectSection(ProjectDependencies) = postProject
-		{4A6465DC-D757-43F2-9180-60920E33522B} = {4A6465DC-D757-43F2-9180-60920E33522B}
+		{D80CE629-FF34-448B-BF5C-99C89AEE2360} = {D80CE629-FF34-448B-BF5C-99C89AEE2360}
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D} = {02D95A67-9434-4EBC-9A55-0F5DF912B61D}
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib_samples", "pjlib_samples.vcproj", "{C1B9C84B-CE30-45D7-A322-986786CE29D5}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib_samples", "pjlib_samples.vcproj", "{6D35E3D7-D511-45D5-8D18-1085F45981EB}"
 	ProjectSection(ProjectDependencies) = postProject
-		{4A6465DC-D757-43F2-9180-60920E33522B} = {4A6465DC-D757-43F2-9180-60920E33522B}
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D} = {02D95A67-9434-4EBC-9A55-0F5DF912B61D}
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib_test", "pjlib_test.vcproj", "{0F28531A-FE4A-4E40-9C7F-763316CA5C9C}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib_test", "pjlib_test.vcproj", "{A078B8BF-BE0B-43D6-8D2B-57B965C7FA09}"
 	ProjectSection(ProjectDependencies) = postProject
-		{4A6465DC-D757-43F2-9180-60920E33522B} = {4A6465DC-D757-43F2-9180-60920E33522B}
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D} = {02D95A67-9434-4EBC-9A55-0F5DF912B61D}
 	EndProjectSection
 EndProject
 Global
-	GlobalSection(SourceCodeControl) = preSolution
-		SccNumberOfProjects = 4
-		SccProjectUniqueName0 = pjlib.vcproj
-		SccProjectName0 = \u0022$/pjproject/pjlib/build\u0022,\u0020UIAAAAAA
-		SccLocalPath0 = .
-		SccProvider0 = MSSCCI:Microsoft\u0020Visual\u0020SourceSafe
-		SccProjectUniqueName1 = pjlib++.vcproj
-		SccProjectName1 = \u0022$/pjproject/pjlib/build\u0022,\u0020UIAAAAAA
-		SccLocalPath1 = .
-		SccProvider1 = MSSCCI:Microsoft\u0020Visual\u0020SourceSafe
-		SccProjectUniqueName2 = pjlib_samples.vcproj
-		SccProjectName2 = \u0022$/pjproject-0.3/pjlib/build\u0022,\u0020EJDAAAAA
-		SccLocalPath2 = .
-		SccProvider2 = MSSCCI:Microsoft\u0020Visual\u0020SourceSafe
-		SccProjectUniqueName3 = pjlib_test.vcproj
-		SccProjectName3 = \u0022$/pjproject/pjlib/build\u0022,\u0020UIAAAAAA
-		SccLocalPath3 = .
-		SccProvider3 = MSSCCI:Microsoft\u0020Visual\u0020SourceSafe
-	EndGlobalSection
 	GlobalSection(SolutionConfiguration) = preSolution
 		Debug = Debug
@@ -48,24 +30,24 @@
 	EndGlobalSection
 	GlobalSection(ProjectConfiguration) = postSolution
-		{4A6465DC-D757-43F2-9180-60920E33522B}.Debug.ActiveCfg = Debug|Win32
-		{4A6465DC-D757-43F2-9180-60920E33522B}.Debug.Build.0 = Debug|Win32
-		{4A6465DC-D757-43F2-9180-60920E33522B}.Release.ActiveCfg = Release|Win32
-		{4A6465DC-D757-43F2-9180-60920E33522B}.Release.Build.0 = Release|Win32
-		{D124EDDD-ED22-43C0-9DDC-279BDEE7DF61}.Debug.ActiveCfg = Debug|Win32
-		{D124EDDD-ED22-43C0-9DDC-279BDEE7DF61}.Debug.Build.0 = Debug|Win32
-		{D124EDDD-ED22-43C0-9DDC-279BDEE7DF61}.Release.ActiveCfg = Release|Win32
-		{D124EDDD-ED22-43C0-9DDC-279BDEE7DF61}.Release.Build.0 = Release|Win32
-		{2B01F39B-FF97-46BF-9CC8-26E3246ACA0E}.Debug.ActiveCfg = Debug|Win32
-		{2B01F39B-FF97-46BF-9CC8-26E3246ACA0E}.Debug.Build.0 = Debug|Win32
-		{2B01F39B-FF97-46BF-9CC8-26E3246ACA0E}.Release.ActiveCfg = Release|Win32
-		{2B01F39B-FF97-46BF-9CC8-26E3246ACA0E}.Release.Build.0 = Release|Win32
-		{C1B9C84B-CE30-45D7-A322-986786CE29D5}.Debug.ActiveCfg = Debug|Win32
-		{C1B9C84B-CE30-45D7-A322-986786CE29D5}.Debug.Build.0 = Debug|Win32
-		{C1B9C84B-CE30-45D7-A322-986786CE29D5}.Release.ActiveCfg = Release|Win32
-		{C1B9C84B-CE30-45D7-A322-986786CE29D5}.Release.Build.0 = Release|Win32
-		{0F28531A-FE4A-4E40-9C7F-763316CA5C9C}.Debug.ActiveCfg = Debug|Win32
-		{0F28531A-FE4A-4E40-9C7F-763316CA5C9C}.Debug.Build.0 = Debug|Win32
-		{0F28531A-FE4A-4E40-9C7F-763316CA5C9C}.Release.ActiveCfg = Release|Win32
-		{0F28531A-FE4A-4E40-9C7F-763316CA5C9C}.Release.Build.0 = Release|Win32
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D}.Debug.ActiveCfg = Debug|Win32
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D}.Debug.Build.0 = Debug|Win32
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D}.Release.ActiveCfg = Release|Win32
+		{02D95A67-9434-4EBC-9A55-0F5DF912B61D}.Release.Build.0 = Release|Win32
+		{D80CE629-FF34-448B-BF5C-99C89AEE2360}.Debug.ActiveCfg = Debug|Win32
+		{D80CE629-FF34-448B-BF5C-99C89AEE2360}.Debug.Build.0 = Debug|Win32
+		{D80CE629-FF34-448B-BF5C-99C89AEE2360}.Release.ActiveCfg = Release|Win32
+		{D80CE629-FF34-448B-BF5C-99C89AEE2360}.Release.Build.0 = Release|Win32
+		{4EB736BB-61BF-4D18-9BBE-1A9ED3E5A115}.Debug.ActiveCfg = Debug|Win32
+		{4EB736BB-61BF-4D18-9BBE-1A9ED3E5A115}.Debug.Build.0 = Debug|Win32
+		{4EB736BB-61BF-4D18-9BBE-1A9ED3E5A115}.Release.ActiveCfg = Release|Win32
+		{4EB736BB-61BF-4D18-9BBE-1A9ED3E5A115}.Release.Build.0 = Release|Win32
+		{6D35E3D7-D511-45D5-8D18-1085F45981EB}.Debug.ActiveCfg = Debug|Win32
+		{6D35E3D7-D511-45D5-8D18-1085F45981EB}.Debug.Build.0 = Debug|Win32
+		{6D35E3D7-D511-45D5-8D18-1085F45981EB}.Release.ActiveCfg = Release|Win32
+		{6D35E3D7-D511-45D5-8D18-1085F45981EB}.Release.Build.0 = Release|Win32
+		{A078B8BF-BE0B-43D6-8D2B-57B965C7FA09}.Debug.ActiveCfg = Debug|Win32
+		{A078B8BF-BE0B-43D6-8D2B-57B965C7FA09}.Debug.Build.0 = Debug|Win32
+		{A078B8BF-BE0B-43D6-8D2B-57B965C7FA09}.Release.ActiveCfg = Release|Win32
+		{A078B8BF-BE0B-43D6-8D2B-57B965C7FA09}.Release.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution